//************************************************************************
//This module contains fitness case and functions to compute raw fitness *
//as well as standardized fitness for Symbolic Regression Problem        *
//Programmed by NXH.                                                     *
//************************************************************************
#ifndef __TRIGONO__
#define __TRIGONO__

#include<iostream.h>
#include<string.h>
#include<stdio.h>
#include<assert.h>
#include<math.h>
#include<stdlib.h>
#include "gconst.h"
#include "stree.h"
#include "random.h"
#define NUMVAR  5
#define NUMFITCASE 32
//****************************************
//Fitness cases for symbolic regression  *
//They are sampled between -1 and 1      *
//Seed for sampling 12345                *
//****************************************
struct _sample{
		 BOOL x[NUMVAR];
		 BOOL y;
		};
typedef struct _sample sample;
sample fitcase[NUMFITCASE];
BOOL SuccPredicate=FALSE;
void SetFitCase()
{
 int i,l,h;
 for(i=0;i<NUMFITCASE;i++)
  {
    h=i;
   for(l=0;l<NUMVAR;l++)
    {
     if((h % 2)==1)
       fitcase[i].x[l]=TRUE;
     else
      fitcase[i].x[l]=FALSE;
     h=h/2;
    }
   h=0;
   for(l=0;l<NUMVAR;l++)
    if(fitcase[i].x[l])
      h++;
   if((h % 2)==0)
    fitcase[i].y=TRUE;
   else
    fitcase[i].y=FALSE;
  }
}
//Some Boolean function
BOOL AND(BOOL a, BOOL b)
{
 if (a&&b)
  return TRUE;
 else
  return FALSE;
}
BOOL OR(BOOL a,BOOL b)
{
 if(a||b)
  return TRUE;
 else
  return FALSE;
}
BOOL NAND(BOOL a,BOOL b)
{
 if(!(a&&b))
  return TRUE;
 else
  return FALSE;
}
BOOL NOR(BOOL a,BOOL b)
{
 if(!(a||b))
  return TRUE;
 else
  return FALSE;
}
BOOL XOR(BOOL a,BOOL b)
{
 if(a!=b)
  return TRUE;
 else 
  return FALSE;
}
BOOL EQ(BOOL a,BOOL b)
{
 if(a==b)
  return TRUE;
 else
  return FALSE;
}
//********************************************************************
//This function compute the function (in tree form) with given input *
//********************************************************************
BOOL Compute(node *st,BOOL x[NUMVAR])
{
 node *p,*q;
 BOOL l,r;
 if (!strcmp(st->name,"X1"))
     return x[0];
  else
    if (!strcmp(st->name,"X2"))
      return x[1];
   else
    if (!strcmp(st->name,"X3"))
     return x[2];
   else
   if (!strcmp(st->name,"X4"))
     return x[3];
    else
      if(!strcmp(st->name,"X5"))
       return x[4];
 else //st->name="BOOL"
  {
    p=st->children;
    q=p->sibling;
    l=Compute(p,x);
  if(q!=NULL) //if there is operator
   {
    r=Compute(q->sibling,x);
    if(!strcmp(q->name,"AND"))
     return AND(l,r);
    else
     if(!strcmp(q->name,"OR"))
       return OR(l,r);
      else
       if (!strcmp(q->name,"NAND"))
	return NAND(l,r);
         else
      // if(!strcmp(q->name,"NOR"))
	return NOR(l,r);
      // if(!strcmp(q->name,"XOR"))
      //  return XOR(l,r);
      //   else
      //     return EQ(l,r);
    }
   else return l;
  }
}
//*********************************************
//Compute the raw fitness for an invidual     *
//*********************************************
double ComputeRF(stree st)
{
  double sum=0;
  BOOL t;
  int i;
  int hit;
  hit=0;
  for(i=0;i<NUMFITCASE;i++)
   {
     t=Compute(st.root,fitcase[i].x);
     if(t==fitcase[i].y)
     {
      hit++;
      sum++;
     }
   }
   if(hit==NUMFITCASE)
     SuccPredicate=TRUE;
   return sum;
}
void BuildVocab()
{
 char *lx[]={"X1","X2","X3","X4","X5"};
 char *lx2[]={"AND","OR","NAND","NOR"};
 int i;
 stree s;
 vocab=new lexicon[2]; assert(vocab!=NULL);
 lexnum=2;
 strcpy(vocab[0].name,"T");
 vocab[0].card=NUMVAR;
 for(i=0;i<NUMVAR;i++)
  {
   s=InitTree(lx[i]);
   vocab[0].lexemes[i].lex=s.root;
   vocab[0].lexemes[i].prob=1.0;
  }
 strcpy(vocab[1].name,"OP");
 vocab[1].card=4;
 for(i=0;i<4;i++)
  {
   s=InitTree(lx2[i]);
   vocab[1].lexemes[i].lex=s.root;
   vocab[1].lexemes[i].prob=1.0;
  }
 NormaliseVD();

}
//****************************************************************
//This function initializes elementary trees and adjoining table *
//****************************************************************

void LoadEtree()
{
 cout<<endl<<"Loading elementary trees...";
 etree=new stree[10];assert(etree!=NULL);
 etree[0]=InitTree("BOOL(T)");
 etree[1]=InitTree("BOOL(BOOL(T),OP,BOOL(BOOL~))");
 etree[2]=InitTree("BOOL(BOOL1(BOOL1(T),OP,BOOL1(T)),OP,BOOL(BOOL~))");
 etree[3]=InitTree("BOOL(BOOL1(BOOL1(T),OP,BOOL1(T)),OP,BOOL1(BOOL1(T),OP,BOOL(BOOL~)))");
 numetree=4;
 numalpha=1;
 numbeta=3;
/*
 etree=new stree[6];assert(etree!=NULL);
 etree[0]=InitTree("BOOL(T)");
 etree[1]=InitTree("BOOL(BOOL(T),AND,BOOL~)");
 etree[2]=InitTree("BOOL(BOOL(T),OR,BOOL~)");
 etree[3]=InitTree("BOOL(BOOL(T),NAND,BOOL~)");
 etree[4]=InitTree("BOOL(BOOL(T),NOR,BOOL~)");
 
 numetree=5;
 numalpha=1;
 numbeta=4;
*/
 cout<<"Done!";
 cout<<endl<<"Building Vocabulary...";
 BuildVocab();
 cout<<endl<<"Done!";
 cout<<endl<<"Buiding adjoining table...";
 BuildAdTable();
 cout<<"Done!"<<entrynum;
}
#endif
