#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <assert.h>
#define TRUE 1
#define FALSE 0
typedef unsigned char BOOL;
double *avg1fitness,*avg2fitness; //average fitness, cumulative frequencies
int csolution,*solsize,*cumf; //number of solutions and solutionsize
double avgsolsize=0,stdsolsize=0;//average solutionsize and standard deviation
//input files
FILE *fps,*fkey; //file contain statistics and file conatins keys
//output files
//FILE *fsol,*favg1,*favg2,*fcumf;
int generation, nrun,optsize,coptsize;
//input file name
char keyfilename[80],psprefix[80];
//output file names
char solfilename[80],avg1filename[80],avg2filename[80],cumffilename[80];
void pitoa(int,char *);
FILE *Open_Text_File(char *,BOOL);
main(int argc,char *argv[])
{
 int i,j,key,k;
 int minsize,bestsize;
 double bestfitness,avgf1,avgf2,avgsize; //buffer variables
 char psfilename[80];
 char temp[20];
 FILE *fpt;
 if(argc!=9)
  {
   cout<<endl<<"Commandline Parameter Missing!";
   cout<<endl<<"1- Key Filename";
   cout<<endl<<"2- Statistic file name prefix:";
   cout<<endl<<"3- Number of Generations";
   cout<<endl<<"4- Output solution file name";
   cout<<endl<<"5- Output avg first fitness file name";
   cout<<endl<<"6- Output avg second fitness file name";
   cout<<endl<<"7- Output cumulative frequencies file name";
   cout<<endl<<"8- The optimal size of solution";
   exit(1);
  }
//get commandline parameters
strcpy(keyfilename,argv[1]);
strcpy(psprefix,argv[2]);
generation=atoi(argv[3]);
strcpy(solfilename,argv[4]);
strcpy(avg1filename,argv[5]);
strcpy(avg2filename,argv[6]);
strcpy(cumffilename,argv[7]);
optsize=atoi(argv[8]);
//Ininitialise
csolution=0;
coptsize=0;
avgsolsize=0;
stdsolsize=0;
solsize=new int[500];assert(solsize!=NULL);
avg1fitness=new double[generation];assert(avg1fitness!=NULL);
avg2fitness=new double[generation];assert(avg2fitness!=NULL);
cumf=new int[generation];assert(cumf!=NULL);
for(i=0;i<generation;i++)
 {
  avg1fitness[i]=0;
  avg2fitness[i]=0;
  cumf[i]=0;
 }
//open the key file
fkey=Open_Text_File(keyfilename,TRUE);
fscanf(fkey,"%d%*c",&nrun);
for(i=0;i<nrun;i++)
{
//get the key
 fscanf(fkey,"%d%*c",&key);
//Create input file name
 strcpy(psfilename,psprefix);
 pitoa(key,temp);
 strcat(psfilename,temp);
//open statistic file for reading informations
 fps=Open_Text_File(psfilename,TRUE);
 minsize=30000;
 for(j=0;j<generation;j++)
  {
   fscanf(fps,"%lf%d%lf%lf%lf%*c",&bestfitness,&bestsize,&avgf1,&avgf2,&avgsize);
   //if we find solutions
   if(bestfitness<=0.000001)
    {
     if(minsize==30000) //first time find solution
      for(k=j;k<generation;k++)
       cumf[k]++;
     if(bestsize<minsize)
      minsize=bestsize;//find the smallest solution size
    }
   //updtate other statistics
    avg1fitness[j]+=avgf1;
    avg2fitness[j]+=avgf2;
  }
 //check if found solution
 if(minsize<30000)
  {
   if(minsize==optsize)
    coptsize++;
   solsize[csolution]=minsize;
   csolution++;
  }
 fclose(fps);
}

//compute and out pur statistics
fpt=Open_Text_File(solfilename,FALSE);
fprintf(fpt,"Number of Solutions Found: %d\n",csolution);
fprintf(fpt,"Number of Optimal Solution: %d\n",coptsize);
avgsolsize=0;
for(k=0;k<csolution;k++)
 avgsolsize+=(double) solsize[k];
avgsolsize=avgsolsize/csolution;
stdsolsize=0;
for(k=0;k<csolution;k++)
 stdsolsize+=((double)solsize[k]-avgsolsize)*((double)solsize[k]-avgsolsize);
stdsolsize=sqrt(stdsolsize/csolution);
fprintf(fpt,"Average Smallest Size of Found Solutions: %lf\n",avgsolsize);
fprintf(fpt,"Standard Deviation of Smallest Size of Found Solutions: %lf\n",stdsolsize);
fclose(fpt);

fpt=Open_Text_File(avg1filename,FALSE);
for(k=0;k<generation;k++)
 fprintf(fpt,"%lf\n",log10(avg1fitness[k]/nrun));
fclose(fpt);

fpt=Open_Text_File(avg2filename,FALSE);
for(k=0;k<generation;k++)
 fprintf(fpt,"%lf\n",avg2fitness[k]/nrun);
fclose(fpt);

fpt=Open_Text_File(cumffilename,FALSE);
for(k=0;k<generation;k++)
 fprintf(fpt,"%d ",cumf[k]);
fclose(fpt);

fclose(fkey);
}
void pitoa(int i, char *ch)
{
 int j,k;
 char s[10],s1[10];
 k=10;
 strcpy(s,"");
 while(i>0)
  {
    j=i % k;
   s1[0]=j+'0';
   s1[1]=0;
   strcat(s1,s);
   strcpy(s,s1);
   i=i/k;
  }
 strcpy(ch, s);
}
FILE *Open_Text_File(char *filename,BOOL rw)
{
 FILE *f;
if(rw)
 f=fopen(filename,"rt");
else
 f=fopen(filename,"wt");
 if(f==NULL)
  {
   cout<<endl<<"File Reading/Creation error"<<endl;
   exit(1);
  }
 return f;
}
